/*****************************************************************************
    logfun.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef LOGFUN_H
#define LOGFUN_H

#ifndef _XOPEN_SOURCE_EXTENDED
#define _XOPEN_SOURCE_EXTENDED
#endif

#include <syslog.h>

#ifndef __const
#define __const const
#endif

#define	LOG_MASTER	0x4000

#define LVL_NONE	0
#define LVL_ERR		1
#define LVL_WARNING	2
#define LVL_NOTICE	3
#define LVL_INFO	4
#define LVL_DEBUG	5

#define DO_MSG1 if(msgLevel >= LVL_ERR)     
#define DO_MSG2 if(msgLevel >= LVL_WARNING)
#define DO_MSG3 if(msgLevel >= LVL_NOTICE) 
#define DO_MSG4 if(msgLevel >= LVL_INFO)
#define DO_MSG5 if(msgLevel >= LVL_DEBUG)
#define DO_MSG6 if(msgLevel >  LVL_DEBUG)

#define LOG_MSG1 DO_MSG1 doLog
#define LOG_MSG2 DO_MSG2 doLog
#define LOG_MSG3 DO_MSG3 doLog
#define LOG_MSG4 DO_MSG4 doLog
#define LOG_MSG5 DO_MSG5 doLog
#define LOG_MSG6 DO_MSG6 doLog

#define STAT_SHORT	1
#define STAT_LONG	2
#define STAT_SERVER	0x10
#define STAT_CLIENT	0x20

#define LPX_TIME	1
#define LPX_PID		2
#define LPX_MISC	4
#define LPX_ALL		-1

#define INIT_LOGGER	1
#define UPDATE_LOGGER	2
#define FULL_LOGGER	(INIT_LOGGER|UPDATE_LOGGER)

#define LOGTRACE        LOG_MSG5(LOG_DEBUG,"%s@%d(%s)",__FILE__,__LINE__,__FUNCTION__);

#define errNoDynmem err_NoDynmem(__FUNCTION__, __LINE__)

int loglvl2pri(int level);
int logpri2lvl (int priority);
void err_NoDynmem (const char *func, int line);
int getFacilityByName(char *name);
char *getFacilityByValue(int facility);
void startLog (int mode);
void stopLog (void);
void doLog (int priority, char *format, ...);

#endif /* LOGFUN_H */
